summaryrefslogtreecommitdiffstats
path: root/extras/ganesha/ocf
diff options
context:
space:
mode:
Diffstat (limited to 'extras/ganesha/ocf')
-rw-r--r--extras/ganesha/ocf/Makefile.am12
-rw-r--r--extras/ganesha/ocf/ganesha_grace168
-rw-r--r--extras/ganesha/ocf/ganesha_mon159
-rw-r--r--extras/ganesha/ocf/ganesha_nfsd196
4 files changed, 535 insertions, 0 deletions
diff --git a/extras/ganesha/ocf/Makefile.am b/extras/ganesha/ocf/Makefile.am
new file mode 100644
index 00000000000..6aed9548a0f
--- /dev/null
+++ b/extras/ganesha/ocf/Makefile.am
@@ -0,0 +1,12 @@
+EXTRA_DIST= ganesha_grace ganesha_mon ganesha_nfsd
+
+# The root of the OCF resource agent hierarchy
+# Per the OCF standard, it's always "lib",
+# not "lib64" (even on 64-bit platforms).
+ocfdir = $(prefix)/lib/ocf
+
+# The provider directory
+radir = $(ocfdir)/resource.d/heartbeat
+
+ra_SCRIPTS = ganesha_grace ganesha_mon ganesha_nfsd
+
diff --git a/extras/ganesha/ocf/ganesha_grace b/extras/ganesha/ocf/ganesha_grace
new file mode 100644
index 00000000000..45819c9a619
--- /dev/null
+++ b/extras/ganesha/ocf/ganesha_grace
@@ -0,0 +1,168 @@
+#!/bin/bash
+#
+# Copyright (c) 2014 Anand Subramanian anands@redhat.com
+# Copyright (c) 2015 Red Hat Inc.
+# All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of version 2 of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+#
+# Further, this software is distributed without any warranty that it is
+# free of the rightful claim of any third person regarding infringement
+# or the like. Any license provided herein, whether implied or
+# otherwise, applies only to this software file. Patent licenses, if
+# any, provided herein do not apply to combinations of this program with
+# other software, or any other product whatsoever.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
+#
+#
+
+# Initialization:
+: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+
+if [ -n "$OCF_DEBUG_LIBRARY" ]; then
+ . $OCF_DEBUG_LIBRARY
+else
+ : ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+fi
+
+ganesha_meta_data() {
+ cat <<END
+<?xml version="1.0"?>
+<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
+<resource-agent name="ganesha_grace">
+<version>1.0</version>
+
+<longdesc lang="en">
+This Linux-specific resource agent acts as a dummy
+resource agent for nfs-ganesha.
+</longdesc>
+
+<shortdesc lang="en">Manages the user-space nfs-ganesha NFS server</shortdesc>
+
+<parameters>
+</parameters>
+
+<actions>
+<action name="start" timeout="40s" />
+<action name="stop" timeout="40s" />
+<action name="status" depth="0" timeout="20s" interval="5s" />
+<action name="monitor" depth="0" timeout="20s" interval="5s" />
+<action name="meta-data" timeout="20s" />
+</actions>
+</resource-agent>
+END
+
+return $OCF_SUCCESS
+}
+
+ganesha_grace_usage() {
+ echo "ganesha.nfsd USAGE"
+}
+
+# Make sure meta-data and usage always succeed
+case $__OCF_ACTION in
+ meta-data) ganesha_meta_data
+ exit $OCF_SUCCESS
+ ;;
+ usage|help) ganesha_usage
+ exit $OCF_SUCCESS
+ ;;
+ *)
+ ;;
+esac
+
+ganesha_grace_start()
+{
+ local result=""
+ local resourcename=""
+ local deadserver=""
+ local tmpIFS=${IFS}
+
+ # logger "ganesha_grace_start()"
+ # we're here because somewhere in the cluster one or more
+ # of the ganesha.nfsds have died, triggering a floating IP
+ # address to move. Resource constraint location rules ensure
+ # that this is invoked before the floating IP is moved.
+ if [ -d /proc/$(cat /var/run/ganesha.nfsd.pid) ]; then
+ # my ganesha.nfsd is still running
+ # find out which one died?
+
+ pcs status | grep dead_ip-1 | sort > /tmp/.pcs_status
+
+ result=$(diff /var/run/ganesha/pcs_status /tmp/.pcs_status | grep '^>')
+ if [[ ${result} ]]; then
+ # logger "ganesha_grace_start(), ${result}"
+ IFS=$'\n'
+ for line in ${result}; do
+ resourcename=$(echo ${line} | cut -f 1 | cut -d ' ' -f 3)
+ deadserver=${resourcename%"-dead_ip-1"}
+
+ if [[ ${deadserver} ]]; then
+ # logger "ganesha_grace_start(), ${line}"
+ # logger "ganesha_grace_start(), dbus-send --print-reply --system --dest=org.ganesha.nfsd /org/ganesha/nfsd/admin org.ganesha.nfsd.admin.grace string:${deadserver}"
+ dbus-send --print-reply --system --dest=org.ganesha.nfsd /org/ganesha/nfsd/admin org.ganesha.nfsd.admin.grace string:${deadserver}
+ if [ $? -ne 0 ]; then
+ logger "warning: dbus-send --print-reply --system --dest=org.ganesha.nfsd /org/ganesha/nfsd/admin org.ganesha.nfsd.admin.grace string:${deadserver} failed"
+ fi
+ fi
+ done
+ IFS=${tmpIFS}
+ fi
+
+ fi
+ return $OCF_SUCCESS
+}
+
+ganesha_grace_stop()
+{
+
+ # logger "ganesha_grace_stop()"
+ return $OCF_SUCCESS
+}
+
+ganesha_grace_monitor()
+{
+ # logger "ganesha_grace_monitor()"
+ pcs status | grep dead_ip-1 | sort > /var/run/ganesha/pcs_status
+ return $OCF_SUCCESS
+}
+
+ganesha_grace_validate()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_grace_validate
+
+# logger "ganesha_grace ${OCF_RESOURCE_INSTANCE} $__OCF_ACTION"
+
+# Translate each action into the appropriate function call
+case $__OCF_ACTION in
+start) ganesha_grace_start
+ ;;
+stop) ganesha_grace_stop
+ ;;
+status|monitor) ganesha_grace_monitor
+ ;;
+*) ganesha_grace_usage
+ exit $OCF_ERR_UNIMPLEMENTED
+ ;;
+esac
+
+rc=$?
+
+# The resource agent may optionally log a debug message
+ocf_log debug "${OCF_RESOURCE_INSTANCE} $__OCF_ACTION returned $rc"
+exit $rc
+
diff --git a/extras/ganesha/ocf/ganesha_mon b/extras/ganesha/ocf/ganesha_mon
new file mode 100644
index 00000000000..c03d7ee5ec9
--- /dev/null
+++ b/extras/ganesha/ocf/ganesha_mon
@@ -0,0 +1,159 @@
+#!/bin/bash
+#
+# Copyright (c) 2014 Anand Subramanian anands@redhat.com
+# Copyright (c) 2015 Red Hat Inc.
+# All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of version 2 of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+#
+# Further, this software is distributed without any warranty that it is
+# free of the rightful claim of any third person regarding infringement
+# or the like. Any license provided herein, whether implied or
+# otherwise, applies only to this software file. Patent licenses, if
+# any, provided herein do not apply to combinations of this program with
+# other software, or any other product whatsoever.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
+#
+#
+
+# Initialization:
+: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+
+if [ -n "$OCF_DEBUG_LIBRARY" ]; then
+ . $OCF_DEBUG_LIBRARY
+else
+ : ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+fi
+
+ganesha_meta_data() {
+ cat <<END
+<?xml version="1.0"?>
+<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
+<resource-agent name="ganesha_mon">
+<version>1.0</version>
+
+<longdesc lang="en">
+This Linux-specific resource agent acts as a dummy
+resource agent for nfs-ganesha.
+</longdesc>
+
+<shortdesc lang="en">Manages the user-space nfs-ganesha NFS server</shortdesc>
+
+<parameters>
+</parameters>
+
+<actions>
+<action name="start" timeout="40s" />
+<action name="stop" timeout="40s" />
+<action name="status" depth="0" timeout="20s" interval="10s" />
+<action name="monitor" depth="0" timeout="10s" interval="10s" />
+<action name="meta-data" timeout="20s" />
+</actions>
+</resource-agent>
+END
+
+return $OCF_SUCCESS
+}
+
+ganesha_mon_usage() {
+ echo "ganesha.nfsd USAGE"
+}
+
+# Make sure meta-data and usage always succeed
+case $__OCF_ACTION in
+ meta-data) ganesha_meta_data
+ exit $OCF_SUCCESS
+ ;;
+ usage|help) ganesha_usage
+ exit $OCF_SUCCESS
+ ;;
+ *)
+ ;;
+esac
+
+ganesha_mon_start()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_mon_stop()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_mon_monitor()
+{
+ local short_host=$(hostname -s)
+
+ if [ -d /proc/$(cat /var/run/ganesha.nfsd.pid) ]; then
+ # logger "ganesha_mon_monitor(), attrd_updater -n ganesha-active -v 1"
+ pcs resource delete ${short_host}-dead_ip-1
+ # if [ $? -ne 0 ]; then
+ # logger "warning: pcs resource delete ${short_host}-dead_ip-1"
+ # fi
+
+ sleep 1
+
+ attrd_updater -n ganesha-active -v 1
+ if [ $? -ne 0 ]; then
+ logger "warning: attrd_updater -n ganesha-active -v 1 failed"
+ fi
+
+ else
+ # logger "ganesha_mon_monitor(), attrd_updater --D -n ganesha-active"
+
+ pcs resource create ${short_host}-dead_ip-1 ocf:heartbeat:Dummy
+ if [ $? -ne 0 ]; then
+ logger "warning: pcs resource create ${short_host}-dead_ip-1 ocf:heartbeat:Dummy failed"
+ fi
+
+ sleep 1
+
+ attrd_updater -D -n ganesha-active
+ if [ $? -ne 0 ]; then
+ logger "warning: attrd_updater -D -n ganesha-active failed"
+ fi
+ fi
+
+ return $OCF_SUCCESS
+}
+
+ganesha_mon_validate()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_mon_validate
+
+# logger "ganesha_mon ${OCF_RESOURCE_INSTANCE} $__OCF_ACTION"
+
+# Translate each action into the appropriate function call
+case $__OCF_ACTION in
+start) ganesha_mon_start
+ ;;
+stop) ganesha_mon_stop
+ ;;
+status|monitor) ganesha_mon_monitor
+ ;;
+*) ganesha_mon_usage
+ exit $OCF_ERR_UNIMPLEMENTED
+ ;;
+esac
+
+rc=$?
+
+# The resource agent may optionally log a debug message
+ocf_log debug "${OCF_RESOURCE_INSTANCE} $__OCF_ACTION returned $rc"
+exit $rc
+
diff --git a/extras/ganesha/ocf/ganesha_nfsd b/extras/ganesha/ocf/ganesha_nfsd
new file mode 100644
index 00000000000..2c0b32c7817
--- /dev/null
+++ b/extras/ganesha/ocf/ganesha_nfsd
@@ -0,0 +1,196 @@
+#!/bin/bash
+#
+# Copyright (c) 2014 Anand Subramanian anands@redhat.com
+# Copyright (c) 2015 Red Hat Inc.
+# All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of version 2 of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+#
+# Further, this software is distributed without any warranty that it is
+# free of the rightful claim of any third person regarding infringement
+# or the like. Any license provided herein, whether implied or
+# otherwise, applies only to this software file. Patent licenses, if
+# any, provided herein do not apply to combinations of this program with
+# other software, or any other product whatsoever.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
+#
+#
+
+# Initialization:
+: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+
+if [ -n "$OCF_DEBUG_LIBRARY" ]; then
+ . $OCF_DEBUG_LIBRARY
+else
+ : ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
+fi
+
+ganesha_meta_data() {
+ cat <<END
+<?xml version="1.0"?>
+<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
+<resource-agent name="ganesha_nfsd">
+<version>1.0</version>
+
+<longdesc lang="en">
+This Linux-specific resource agent acts as a dummy
+resource agent for nfs-ganesha.
+</longdesc>
+
+<shortdesc lang="en">Manages the user-space nfs-ganesha NFS server</shortdesc>
+
+<parameters>
+<parameter name="ha_vol_name">
+<longdesc lang="en">HA State Volume Name</longdesc>
+<shortdesc lang="en">HA_State Volume Name</shortdesc>
+<content type="string" default="" />
+</parameter>
+
+<parameter name="ha_vol_mnt">
+<longdesc lang="en">HA State Volume Mount Point</longdesc>
+<shortdesc lang="en">HA_State Volume Mount Point</shortdesc>
+<content type="string" default="" />
+</parameter>
+
+<parameter name="ha_vol_server">
+<longdesc lang="en">HA State Volume Server</longdesc>
+<shortdesc lang="en">HA_State Volume Server</shortdesc>
+<content type="string" default="" />
+</parameter>
+</parameters>
+
+<actions>
+<action name="start" timeout="40s" />
+<action name="stop" timeout="40s" />
+<action name="status" depth="0" timeout="20s" interval="1m" />
+<action name="monitor" depth="0" timeout="10s" interval="1m" />
+<action name="meta-data" timeout="20s" />
+</actions>
+</resource-agent>
+END
+
+return $OCF_SUCCESS
+}
+
+ganesha_nfsd_usage() {
+ echo "ganesha.nfsd USAGE"
+}
+
+# Make sure meta-data and usage always succeed
+case $__OCF_ACTION in
+ meta-data) ganesha_meta_data
+ exit $OCF_SUCCESS
+ ;;
+ usage|help) ganesha_usage
+ exit $OCF_SUCCESS
+ ;;
+ *)
+ ;;
+esac
+
+ganesha_nfsd_start()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_nfsd_stop()
+{
+ local mounted=""
+ local mntptinuse=""
+ local instance_host=""
+ local short_host=""
+ local resource_prefix=${OCF_RESOURCE_INSTANCE:0:9}
+
+ if [ "X${resource_prefix}X" = "Xnfs_startX" ]; then
+
+ mounted=$(mount | grep $OCF_RESKEY_ha_vol_name)
+ mntptinuse=$(mount | grep -o $OCF_RESKEY_ha_vol_mnt)
+ short_host=$(hostname -s)
+ long_host=$(hostname)
+
+ if [[ ! ${mounted} ]]; then
+
+ if [ -d $OCF_RESKEY_ha_vol_mnt ]; then
+ if [[ ${mntptinuse} ]]; then
+ return $OCF_ERR_GENERIC
+ fi
+ else
+ mkdir ${mntpt}
+ fi
+
+ mount -t glusterfs $OCF_RESKEY_ha_vol_server:$OCF_RESKEY_ha_vol_name $OCF_RESKEY_ha_vol_mnt
+ if [ $? -ne 0 ]; then
+ logger "warning: mount -t glusterfs $OCF_RESKEY_ha_vol_server:$OCF_RESKEY_ha_vol_name $OCF_RESKEY_ha_vol_mnt failed"
+ fi
+
+ mv /var/lib/nfs /var/lib/nfs.backup
+ ln -s $OCF_RESKEY_ha_vol_mnt/${long_host}/nfs /var/lib/nfs
+ if [ $? -ne 0 ]; then
+ logger "warning: ln -s $OCF_RESKEY_ha_vol_mnt/${long_host}/nfs /var/lib/nfs failed"
+ fi
+
+ fi
+
+ service nfs-ganesha start
+ if [ $? -ne 0 ]; then
+ logger "warning: service nfs-ganesha start failed"
+ fi
+ else
+ umount $OCF_RESKEY_ha_vol_mnt
+ if [ $? -ne 0 ]; then
+ logger "warning: umount $OCF_RESKEY_ha_vol_mnt failed"
+ fi
+
+ service nfs-ganesha stop
+ if [ $? -ne 0 ]; then
+ logger "warning: service nfs-ganesha stop failed"
+ fi
+ fi
+
+ return $OCF_SUCCESS
+}
+
+ganesha_nfsd_monitor()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_nfsd_validate()
+{
+ return $OCF_SUCCESS
+}
+
+ganesha_nfsd_validate
+
+# logger "ganesha_nfsd ${OCF_RESOURCE_INSTANCE} $__OCF_ACTION"
+
+# Translate each action into the appropriate function call
+case $__OCF_ACTION in
+start) ganesha_nfsd_start
+ ;;
+stop) ganesha_nfsd_stop
+ ;;
+status|monitor) ganesha_nfsd_monitor
+ ;;
+*) ganesha_nfsd_usage
+ exit $OCF_ERR_UNIMPLEMENTED
+ ;;
+esac
+
+rc=$?
+
+# The resource agent may optionally log a debug message
+ocf_log debug "${OCF_RESOURCE_INSTANCE} $__OCF_ACTION returned $rc"
+exit $rc
+